
; *****************************************************************************
;
;                   Kdovn soubor na logickm disku
;
; *****************************************************************************

Code     SEGMENT
         ASSUME    cs:Code,ds:Code
         ORG       100h

Start:   jmp       Instal

UvTxt    db        'KODDISK V1.10 ['
UvTxtVar db        'A] - kodovani disku; (c) Miroslav Nemecek',13,10,'$'
UvTxt0   label     byte

SegRez   dw        0                        ; segment rezidentn sti
Old20    dd        0                        ; pvodn adresa INT 20h
Old21    dd        0                        ; pvodn adresa INT 21h
Old27    dd        0                        ; pvodn adresa INT 27h
Disk     db        0                        ; kdovan disk (0=A, ...)
Param    db        0                        ; parametry:
                                            ;   bit 0: 1=funkce zapnuta
                                            ;   bit 1: 1=nekompatibiln systm

KlicN    EQU       257                      ; dlka kle
Klic     db        KlicN dup(0)             ; kdovac kl

MaxIdent EQU       128                      ; maximln poet identifiktor
Ident    dw        MaxIdent dup(-1)         ; tabulka identifiktor

FCB      db        37 dup(0)                ; uschovan vzor FCB
DTA      dd        0                        ; uschovan adresa DTA

PushRet  dw        0                        ; schova nvratov adresy

; -----------------------------------------------------------------------------
;        obsluha INT 20h
; -----------------------------------------------------------------------------

Int20    PROC      FAR

         call      NulId
         jmp       dword ptr cs:[Old20]

Int20    ENDP

; -----------------------------------------------------------------------------
;        obsluha INT 27h
; -----------------------------------------------------------------------------

Int27    PROC      FAR

         call      NulId
         jmp       dword ptr cs:[Old27]

Int27    ENDP

; -----------------------------------------------------------------------------
;        obsluha INT 21h
; -----------------------------------------------------------------------------

Int21x:  pushf
         call      dword ptr cs:[Old21]
         ret


Int21    PROC      FAR

         cmp       ah,9                     ; zobrazen textu ?
         jne       Int211                   ; nen zobrazen textu
         cmp       dx,offset UvTxt          ; vodn text ?
         jne       Int210                   ; nen vodn text

         pushf
         push      si
         push      di
         push      cx
         push      es
         push      cs
         pop       es
         mov       si,dx
         mov       di,dx
         mov       cx,offset(UvTxt0-UvTxt)  ; dlka vodnho textu
         cld
         repe      cmpsb                    ; porovnn text
         pop       es
         pop       cx
         pop       di
         pop       si
         jne       Int2100                  ; nen vodn text
         mov       ds:[SegRez],cs           ; segment rezidentn sti
Int2100: popf

Int210:  jmp       dword ptr cs:[Old21]

; ------ sekvenn ten ze souboru FCB

Int211:  cmp       ah,14h
         jne       Int212

         call      UlozFCB                  ; schova FCB
         call      TestFCB                  ; kontrola, zda je platn disk
         jne       Int210                   ; nen platn disk

         call      PushFCB                  ; schova FCB
         call      Int21x                   ; sekvenn ten dat
         call      PopFCB                   ; nvrat FCB

         cmp       al,1                     ; peteno nco ?
         je        Int2127                  ; nic nepeteno
         cmp       al,2                     ; chyba DTA ?
         je        Int2127                  ; chyba DTA
         call      DekRFCB                  ; dekdovn dat po ten FCB
Int2127: iret

; ------ sekvenn zpis do souboru FCB

Int212:  cmp       ah,15h
         jne       Int213

         call      UlozFCB                  ; schova FCB
         call      TestFCB                  ; kontrola, zda je platn disk
         jne       Int210                   ; nen platn disk

         call      DekWFCB                  ; zakdovn dat ped zpisem
         jc        Int210                   ; chyba - peteen dlky dat

         call      PushFCB                  ; schova FCB
         call      Int21x                   ; sekvenn zpis dat
         call      PopFCB                   ; nvrat FCB

         call      DekRFCB                  ; dekdovn dat po zpisu
         iret

Int2126: jmp       Int21y

; ------ ten s pmm pstupem FCB

Int213:  cmp       ah,21h
         jne       Int214

         call      UlozFCB                  ; schova FCB
         call      TestFCB                  ; kontrola, zda je platn disk
         jne       Int2126                  ; nen platn disk

         call      PushFCB                  ; schova FCB
         call      Int21x                   ; sekvenn ten dat
         call      PopFCB                   ; nvrat FCB

         cmp       al,1                     ; peteno nco ?
         je        Int2137                  ; nic nepeteno
         cmp       al,2                     ; chyba DTA ?
         je        Int2137                  ; chyba DTA
         push      cx
         mov       cx,1                     ; 1 zznam
         call      DekRFCR                  ; dekdovn dat po ten FCB
         pop       cx
Int2137: iret

; ------ zpis s pmm pstupem FCB

Int214:  cmp       ah,22h
         jne       Int215

         call      UlozFCB                  ; schova FCB
         call      TestFCB                  ; kontrola, zda je platn disk
         jne       Int2126                  ; nen platn disk

         push      cx
         mov       cx,1                     ; 1 zznam
         call      DekWFCR                  ; zakdovn dat ped zpisem
         pop       cx
         jc        Int2126                  ; chyba - peteen dlky dat

         call      PushFCB                  ; schova FCB
         call      Int21x                   ; zakdovn dat ped zpisem
         call      PopFCB                   ; nvrat FCB

         push      cx
         mov       cx,1                     ; 1 zznam
         call      DekRFCR                  ; nvrat dat po zpisu
         pop       cx
         iret

; ------ dlouh ten s pmm pstupem FCB

Int215:  cmp       ah,27h
         jne       Int216

         call      UlozFCB                  ; schova FCB
         call      TestFCB                  ; kontrola, zda je platn disk
         jne       Int2126                  ; nen platn disk

         call      PushFCB                  ; schova FCB
         call      Int21x                   ; sekvenn ten dat
         call      PopFCB                   ; nvrat FCB

         cmp       al,1                     ; peteno nco ?
         je        Int2157                  ; nic nepeteno
         cmp       al,2                     ; chyba DTA ?
         je        Int2157                  ; chyba DTA
         call      DekRFCR                  ; dekdovn dat po ten FCB
Int2157: iret

; ------ dlouh zpis s pmm pstupem FCB

Int216:  cmp       ah,28h
         jne       Int217

         call      UlozFCB                  ; schova FCB
         call      TestFCB                  ; kontrola, zda je platn disk
         jne       Int2177                  ; nen platn disk

         call      DekWFCR                  ; zakdovn dat ped zpisem
         jc        Int2177                  ; chyba - peteen dlky dat

         call      PushFCB                  ; schova FCB
         call      Int21x                   ; zakdovn dat ped zpisem
         call      PopFCB                   ; nvrat FCB

         call      DekRFCR                  ; nvrat dat po zpisu
         iret

; ------ vytvoen, oteven souboru identifiktorem

Int217:  cmp       ah,3dh
         je        Int2171                  ; oteven souboru
         cmp       ah,5ah
         je        Int2171                  ; vytvoen jedinenho souboru
         cmp       ah,5bh
         je        Int2171                  ; vytvoen souboru
         cmp       ah,3ch                   ; vytvoen souboru
         jne       Int218
Int2171: call      TestFil                  ; test jmna souboru
         jne       Int2177                  ; nen platn disk
Int2172: call      Int21x                   ; vytvoen poadovanho souboru
         jc        Int217R                  ; soubor nebyl vytvoen
         push      ax
         call      KodId                    ; pekdovn identifiktoru
         call      StorId                   ; uloen identifiktoru do seznamu
         pop       ax
Int217R:
                                            ; SS:[BP+8]=Flag
                                            ; SS:[BP+6]=CS
                                            ; SS:[BP+4]=IP
         push      bp                       ; SS:[BP+2]=BP
         push      ax                       ; SS:[BP+0]=AX
         mov       bp,sp                    ; ukazatel dat v zsobnku
         pushf
         pop       ax                       ; AX <- Flag
         mov       ss:[bp+8],al             ; navrcen pznaky
         pop       ax
         pop       bp
         iret

Int2177: jmp       Int21y

; ------ uzaven souboru

Int218:  cmp       ah,3eh
         jne       Int21a
         push      ax
         mov       ax,bx                    ; identifiktor
         call      KodId                    ; pekdovn identifiktoru
         call      DelId                    ; zruen identifiktoru ze seznamu
         pop       ax
         jmp       short Int2177

; ------ ten ze souboru pomoc identifiktoru

Int21A:  cmp       ah,3fh
         jne       Int21B

         push      ax
         mov       ax,bx                    ; identifiktor
         call      KodId                    ; pekdovn identifiktoru
         call      TestId                   ; test identifiktoru
         pop       ax
         jne       Int2177                  ; nen kdovan soubor

         push      bx
         call      AdrId                    ; adresa (fze) v souboru
         mov       cs:[PushRet],bx          ; schova BX
         pop       bx

         push      word ptr cs:[PushRet]
         call      Int21x
         pop       word ptr cs:[PushRet]
         jc        Int217R                  ; chyba ten

         pushf
         push      bx
         push      cx
         push      di
         push      es

         push      ds
         pop       es                       ; segment adresy bufferu
         mov       di,dx                    ; offset adresy bufferu
         mov       cx,ax                    ; dlka natench dat
         mov       bx,cs:[PushRet]          ; fze potku dat v souboru
         call      Dekod                    ; dekdovn dat po ten

         pop       es
         pop       di
         pop       cx
         pop       bx
         popf
         jmp       short Int217R

; ------ zpis do souboru pomoc identifiktoru

Int21B:  cmp       ah,40h
         jne       Int21C

         push      ax
         mov       ax,bx                    ; identifiktor souboru
         call      KodId                    ; pekdovn identifiktoru
         call      TestId                   ; test identifiktoru
         pop       ax
Int21777:jne       Int2177                  ; nen kdovan soubor

         push      bx
         push      di
         push      es

         push      ds
         pop       es                       ; segment adresy bufferu
         mov       di,dx                    ; offset adresy bufferu
         call      AdrId                    ; adresa (fze) v souboru
         mov       cs:[PushRet],bx          ; schova BX
         call      Kod                      ; kdovn dat ped zpisem

         pop       es
         pop       di
         pop       bx

         push      word ptr cs:[PushRet]
         call      Int21x
         pop       word ptr cs:[PushRet]

         pushf
         push      bx
         push      di
         push      es

         push      ds
         pop       es                       ; segment adresy bufferu
         mov       di,dx                    ; offset adresy bufferu
         mov       bx,cs:[PushRet]          ; fze potku dat v souboru
         call      Dekod                    ; dekdovn dat po zpisu

         pop       es
         pop       di
         pop       bx
         popf
         jmp       short Int217R2

; ------ zdvojen identifiktoru souboru

Int21C:  cmp       ah,45h
         jne       Int21D

         push      ax
         mov       ax,bx                    ; identifiktor souboru
         call      KodId                    ; pekdovn identifiktoru
         call      TestId                   ; test identifiktoru
         pop       ax
         jne       Int21777                 ; nen kdovan soubor
         jmp       Int2172                  ; uloen identifiktoru

; ------ nucen zdvojen identifiktoru

Int21D:  cmp       ah,46h
         jne       Int21E

         call      Int21x                   ; obsluha funkce
         jc        Int217R2                 ; nespn operace
         pushf
         push      ax
         mov       ax,cx                    ; vyazovan soubor
         call      KodId                    ; pekdovn identifiktoru
         call      DelId                    ; vyazen souboru
         mov       ax,bx                    ; vzorov soubor
         call      KodId                    ; pekdovn identifiktoru
         call      TestId
         jne       Int21D4                  ; nen obsluhovan
         mov       ax,cx
         call      KodId                    ; pekdovn identifiktoru
         call      StorId                   ; uloen zdvojenho souboru
Int21D4: pop       ax
         popf
Int217R2:jmp       Int217R

; ------ ukonen programu - automatick uzaven soubor

Int21E:  cmp       ah,0
         je        Int21E2
         cmp       ah,4ch
         je        Int21E2
         cmp       ah,31h
         jne       Int21F
Int21E2: call      NulId                    ; nulovn tabulky identifiktor
Int21E7: jmp       short Int21y

; ------ rozen oteven souboru

Int21F:  cmp       ax,6c00h
         jne       Int21G

         push      dx
         mov       dx,si                    ; jmno souboru
         call      TestFil                  ; test jmna souboru
         pop       dx
         jne       Int21E7                  ; nen platn disk
         call      Int21x                   ; vytvoen poadovanho souboru
         jc        Int217R2                 ; soubor nebyl vytvoen
         push      ax
         call      KodId                    ; pekdovn identifiktoru
         call      StorId                   ; uloen identifiktoru do seznamu
         pop       ax
         jmp       short Int217R2

Int21G:

Int219:
Int21y:
         jmp       dword ptr cs:[Old21]

Int21    ENDP

; -----------------------------------------------------------------------------
;        schova FCB do zsobnku
; -----------------------------------------------------------------------------

PushFCB  PROC      NEAR

         pop       word ptr cs:[PushRet]

         push      word ptr cs:[FCB+0]      ; disk
         push      word ptr cs:[FCB+0ch]    ; aktuln blok
         push      word ptr cs:[FCB+0eh]    ; dlka jednoho zznamu
         push      word ptr cs:[FCB+20H]    ; aktuln zznam a relativn zznam

         push      word ptr cs:[DTA]        ; schova DTA - LOW
         push      word ptr cs:[DTA+2]      ; schova DTA - HIGH

         jmp       word ptr cs:[PushRet]

PushFCB  ENDP

; -----------------------------------------------------------------------------
;        nvrat FCB ze zsobnku
; -----------------------------------------------------------------------------

PopFCB   PROC      NEAR

         pop       word ptr cs:[PushRet]

         pop       word ptr cs:[DTA+2]      ; schova DTA - HIGH
         pop       word ptr cs:[DTA]        ; schova DTA - LOW

         pop       word ptr cs:[FCB+20H]    ; aktuln zznam a relativn zznam
         pop       word ptr cs:[FCB+0eh]    ; dlka jednoho zznamu
         pop       word ptr cs:[FCB+0ch]    ; aktuln blok
         pop       word ptr cs:[FCB+0]      ; disk

         jmp       word ptr cs:[PushRet]

PopFCB   ENDP

; -----------------------------------------------------------------------------
;        nulovn tabulky identifiktor
; -----------------------------------------------------------------------------

NulId    PROC      NEAR

         pushf
         push      ax
;         push      cx
;         push      di
;         push      es

         mov       ax,5                     ; prvn identifiktor
NulId2:  push      ax
         call      KodId                    ; pekdovn identifiktoru
         call      DelId                    ; vyazen souboru
         pop       ax
         inc       ax
         cmp       ax,20
         jb        NulId2

;         cld
;         push      cs
;         pop       es
;         mov       di,offset Ident
;         mov       ax,-1
;         mov       cx,MaxIdent              ; maxim. poet identifiktor
;         rep       stosw

;         pop       es
;         pop       di
;         pop       cx
         pop       ax
         popf
         ret

NulId    ENDP

; -----------------------------------------------------------------------------
;        pekdovn loklnho identifiktoru AX na veejn
; -----------------------------------------------------------------------------

KodId    PROC      NEAR

; ------ schova registr

         pushf
         push      bx
         push      si
         push      es

; ------ kontrola kompatibility systmu

         test      byte ptr cs:[Param],2    ; je kompatibiln systm ?
         jnz       KodId9                   ; nekompatibiln systm

; ------ kontrola maximlnho sla identifiktoru

         cmp       ax,20
         jae       KodId9                   ; pekroeno max. slo identifik.
         mov       si,ax                    ; identifiktor

; ------ poskytnut aktivnho PSP

         mov       ah,51h
         call      Int21x                   ; poskytnut adresy aktivnho PSP
         mov       es,bx                    ; adresa aktivnho PSP

; ------ transformace identifiktoru podle tabulky

         xor       ax,ax
         mov       al,es:[si+18h]           ; transformace identifiktoru
         cmp       al,0ffh                  ; je platn identifiktor ?
         jne       KodId9                   ; je platn identifiktor
         mov       ax,si                    ; nvrat pvodnho identifiktoru

; ------ nvrat registr

KodId9:  pop       es
         pop       si
         pop       bx
         popf
         ret

KodId    ENDP


; -----------------------------------------------------------------------------
;        Uloen identifiktoru AX souboru do seznamu soubor
; -----------------------------------------------------------------------------

StorId   PROC      NEAR

         pushf
         push      si
         push      cx

; ------ test, zda identifiktor ji je v tabulce

         mov       cx,MaxIdent              ; max. poet identifiktor
         mov       si,offset Ident          ; tabulka identifiktor
StorId1: cmp       word ptr cs:[si],ax      ; je ji takov identifiktor ?
         je        StorId9                  ; je ji takov identifiktor
         inc       si
         inc       si
         loop      StorId1                  ; dal identifiktor

; ------ nalezen voln poloky v tabulce

         mov       cx,MaxIdent              ; max. poet identifiktor
         mov       si,offset Ident-2        ; tabulka identifiktor
StorId2: inc       si
         inc       si
         cmp       word ptr cs:[si],-1      ; je voln poloka ?
         loopne    StorId2                  ; nalezen voln poloky
         jne       StorId9                  ; poloka nenalezena

         mov       cs:[si],ax               ; schova identifiktoru souboru

StorId9: pop       cx
         pop       si
         popf
         ret

StorId   ENDP

; -----------------------------------------------------------------------------
;        zruen identifiktoru AX ze seznamu soubor
; -----------------------------------------------------------------------------

DelId    PROC      NEAR

         pushf
         push      si
         push      cx

; ------ nalezen identifiktoru v tabulce

         mov       cx,MaxIdent              ; max. poet identifiktor
         mov       si,offset Ident-2        ; tabulka identifiktor
DelId1:  inc       si
         inc       si
         cmp       word ptr cs:[si],ax      ; nalezen identifiktor ?
         loopne    DelId1                   ; nenalezen - dal identifiktor
         jne       DelId9                   ; identifiktor nenalezen

         mov       word ptr cs:[si],-1      ; zruen identifiktoru

DelId9:  pop       cx
         pop       si
         popf
         ret

DelId    ENDP

; -----------------------------------------------------------------------------
;        test, zda je identifiktor AX v seznamu soubor
; -----------------------------------------------------------------------------

TestId   PROC      NEAR

         push      di
         push      cx
         push      es

; ------ nalezen identifiktoru v tabulce

         push      cs
         pop       es
         cld
         mov       cx,MaxIdent              ; max. poet identifiktor
         mov       di,offset Ident          ; tabulka identifiktor
         repne     scasw                    ; nalezen identifiktoru v tabulce

         pop       es
         pop       cx
         pop       di
         ret

TestId   ENDP



; -----------------------------------------------------------------------------
;        schova vzoru FCB DS:DX (a DTA)
; -----------------------------------------------------------------------------

UlozFCB  PROC      NEAR

         pushf
         push      ax
         push      bx
         push      si
         push      di
         push      cx
         push      es

         cld
         push      cs
         pop       es
         mov       di,offset FCB
         mov       cx,37                    ; dlka FCB
         mov       si,dx
         cmp       byte ptr ds:[si],0ffh
         jne       UlozFCB1                 ; nen rozen FCB
         add       si,7
UlozFCB1:rep       movsb                    ; schova FCB

         mov       ah,2fh
         call      Int21x                   ; poskytnut adresy DTA
         mov       word ptr cs:[DTA],bx
         mov       word ptr cs:[DTA+2],es

         pop       es
         pop       cx
         pop       di
         pop       si
         pop       bx
         pop       ax
         popf
         ret

UlozFCB  ENDP

; -----------------------------------------------------------------------------
;        Test jmna souboru, zda je poadovan disk
; -----------------------------------------------------------------------------

TestFil  PROC      NEAR

         push      ax
         push      si
         mov       si,dx

; ------ nalezen oznaen disku

         cld                                ; smr nahoru
TestFil1:lodsb                              ; naten znaku
         cmp       al," "                   ; je mezera ?
         je        TestFil1                 ; je mezera - ignorovn
         cmp       al,9                     ; je tabeltor ?
         je        TestFil1                 ; je tabeltor - ignorovn

; ------ pevod oznaen disku na velk psmeno

         cmp       al,"a"
         jb        TestFil2
         cmp       al,"z"
         ja        TestFil2
         sub       al,32                    ; korekce na velk psmeno
TestFil2:sub       al,"A"                   ; slo disku

; ------ stanoven implicitnho disku

         cmp       byte ptr ds:[si],":"     ; je to oznaen disku ?
         je        TestFil3                 ; je to oznaen disku
         mov       ah,19h
         call      Int21x                   ; poskytnut aktivnho disku

; ------ test, zda je kdovan disk

TestFil3:cmp       al,cs:[Disk]             ; je to kdovan disk ?

         pop       si
         pop       ax
         ret

TestFil  ENDP

; -----------------------------------------------------------------------------
;        Test poloky FCB, zda je poadovan disk
; -----------------------------------------------------------------------------

TestFCB  PROC      NEAR

         push      ax

; ------ test sla disku

         mov       al,cs:[FCB]
         or        al,al                    ; je aktuln disk ?
         jnz       TestFCB2                 ; nen aktuln disk
         mov       ah,19h
         call      Int21x                   ; poskytnut aktivnho disku
         inc       al                       ; pednastaven sla disku
TestFCB2:dec       al                       ; slo disku (0=A atd.)
         cmp       al,cs:[Disk]             ; je to kdovan disk ?

         pop       ax
         ret

TestFCB  ENDP


; -----------------------------------------------------------------------------
;        dekdovn dat ped zpisem FCB - rel. zznam
; -----------------------------------------------------------------------------

DekWFCR  PROC      NEAR

         push      ax
         push      bx
         push      cx
         push      di
         push      es

; ------ fze a dlka dat

         call      AdrRFCB                  ; poskytnut adresy dat z FCB - rel.
         jmp       short DekWFCB0

DekWFCR  ENDP

; -----------------------------------------------------------------------------
;        zakdovn dat ped zpisem FCB (1 zznam) - blok
; -----------------------------------------------------------------------------

DekWFCB  PROC      NEAR

         push      ax
         push      bx
         push      cx
         push      di
         push      es

; ------ fze a dlka dat

         call      AdrBFCB                  ; poskytnut adresy dat z FCB - blok
DekWFCB0:jc        DekWFCB2                 ; chyba - peteen dlky dat

; ------ poskytnut adresy dat - adresa DTA

DekWFCB1:les       di,cs:[DTA]              ; adresa DTA

; ------ dekdovn dat ped zpisem FCB

         call      Kod                      ; zakdovn dat FCB

DekWFCB2:pop       es
         pop       di
         pop       cx
         pop       bx
         pop       ax
         ret

DekWFCB  ENDP

; -----------------------------------------------------------------------------
;        dekdovn dat po ten FCB - rel. zznam
; -----------------------------------------------------------------------------

DekRFCR  PROC      NEAR

         push      ax
         push      bx
         push      cx
         push      di
         push      es

; ------ fze a dlka dat

         call      AdrRFCB                  ; poskytnut adresy dat z FCB - rel.
         jmp       short DekRFCB1

DekRFCR  ENDP

; -----------------------------------------------------------------------------
;        rozkdovn dat natench pi operaci FCB (1 zznam) - blok
; -----------------------------------------------------------------------------

DekRFCB  PROC      NEAR

         push      ax
         push      bx
         push      cx
         push      di
         push      es

; ------ fze a dlka dat

         call      AdrBFCB                  ; poskytnut adresy dat z FCB - blok

; ------ poskytnut adresy dat - adresa DTA

DekRFCB1:les       di,cs:[DTA]              ; adresa DTA

; ------ dekdovn dat natench pi operaci FCB

         call      Dekod                    ; dekdovn dat FCB

         pop       es
         pop       di
         pop       cx
         pop       bx
         pop       ax
         ret

DekRFCB  ENDP

; -----------------------------------------------------------------------------
;        poskytnut fze BL identifiktoru BX
; -----------------------------------------------------------------------------

AdrId    PROC      NEAR

         push      ax
         push      cx
         push      dx

         mov       ax,4201h
         xor       cx,cx
         xor       dx,dx
         call      Int21x                   ; poskytnut ukazatele souboru
         mov       bl,al                    ; fze souboru

         pop       dx
         pop       cx
         pop       ax
         ret

AdrId    ENDP

; -----------------------------------------------------------------------------
;        poskytnut fze BL a dlky CX dat z FCB/CX zzn. (CY=peteen) - rel.
; -----------------------------------------------------------------------------

AdrRFCB  PROC      NEAR

         push      ax
         push      dx

         mov       al,cs:[FCB+21h]          ; rel. zznam - nejni bajt
         jmp       short AdrFCB2

AdrRFCB  ENDP

; -----------------------------------------------------------------------------
;        poskytnut fze BL a dlky CX dat z FCB/1 zzn.  (CY=peteen) - blok
; -----------------------------------------------------------------------------

AdrBFCB  PROC      NEAR

         push      ax
         push      dx
         mov       cx,1                     ; 1 zznam

; ------ vpoet relativnho zznamu (posta ni slovo)

         xor       ax,ax                    ; AX <- 0
         mov       ah,cs:[FCB+0ch]          ; aktuln blok LOW
         shr       ax,1                     ; pepoet bloku na zznam LOW
         mov       ah,cs:[FCB+20h]          ; aktuln zznam
         and       ah,7fh                   ; nulovn bitu 7
         or        al,ah                    ; aktuln zznam relativn (LOW)

; ------ vpoet fze v souboru

AdrFCB2: mul       byte ptr cs:[FCB+0eh]    ; pepoet zznamu na bajty
         mov       bl,al                    ; fze adresy v souboru (0 a 255)

; ------ vpoet dlky dat k naten

         mov       ax,word ptr cs:[FCB+0eh] ; dlka jednoho zznamu
         mul       cx                       ; vpoet dlky dat k naten
         mov       cx,ax                    ; dlka dat k naten
         or        dx,dx                    ; je peteen segmentu ?
         jz        AdrBFCB9                 ; dlka dat je OK
         stc                                ; pznak chyby peteen dat

AdrBFCB9:pop       dx
         pop       ax
         ret

AdrBFCB  ENDP

; -----------------------------------------------------------------------------
;        zakdovn dat ES:DI/CX ped zpisem, fze BL
; -----------------------------------------------------------------------------
; znien registry: BX
; -----------------------------------------------------------------------------

Kod      PROC      NEAR

; ------ schova registr

         push      ax
         push      cx
         push      dx
         push      si
         push      ds
         push      cs
         pop       ds
         mov       si,offset Klic           ; kdovac kl
         xor       bh,bh                    ; BH <- 0 vy bajt fze
         jcxz      Koda
         test      byte ptr cs:[Param],1    ; je funkce zapnuta ?
         jz        Koda                     ; funkce nen zapnuta
         mov       dx,cx                    ; poet bajt
         cld                                ; smr nahoru

; ------ zakdovn dat

Kod1:    mov       cx,ds:[si+bx]            ; vzorek kle
         mov       al,es:[di]               ; vzorek dat
         and       cl,7                     ; omezen potu rotac
         rol       al,cl                    ; rotace vlevo
         xor       al,ch                    ; maskovn vzorkem dat
         stosb                              ; uloen zakdovanch dat
         inc       bl                       ; zven fze v tabulce kle
         dec       dx                       ; snen tae bajt
         jnz       Kod1                     ; zakdovn dalho bajtu

; ------ nvrat registr

Koda:    pop       ds
         pop       si
         pop       dx
         pop       cx
         pop       ax
         ret

Kod      ENDP

; -----------------------------------------------------------------------------
;        dekdovn dat ES:DI/CX po ten (nebo po zpisu), fze BL
; -----------------------------------------------------------------------------

DeKod    PROC      NEAR

; ------ schova registr

         push      ax
         push      cx
         push      dx
         push      si
         push      ds
         push      cs
         pop       ds
         mov       si,offset Klic           ; kdovac kl
         xor       bh,bh                    ; BH <- 0 vy bajt fze
         jcxz      Dekod2                   ; nejsou dn data
         test      byte ptr cs:[Param],1    ; je funkce zapnuta ?
         jz        DeKod2                   ; funkce nen zapnuta
         mov       dx,cx                    ; poet bajt
         cld                                ; smr nahoru

; ------ dekdovn dat

DeKod1:  mov       cx,ds:[si+bx]            ; vzorek kle
         mov       al,es:[di]               ; vzorek dat
         and       cl,7                     ; omezen potu rotac
         xor       al,ch                    ; odmaskovn vzorku dat
         ror       al,cl                    ; rotace vpravo
         stosb                              ; uloen dekdovanch dat
         inc       bl                       ; zven fze v tabulce kle
         dec       dx                       ; snen tae bajt
         jnz       DeKod1                   ; dekdovn dalho bajtu dat

; ------ nvrat registr

DeKod2:  pop       ds
         pop       si
         pop       dx
         pop       cx
         pop       ax
         ret

DeKod    ENDP


; *****************************************************************************
;
;                        Start a instalace programu
;
; *****************************************************************************

; ------ kontrola kompatibility systmu

Instal:  mov       ds:[SegRez],ds           ; segment tohoto programu
         xor       bx,bx                    ; BX <- 0
         push      ds
         mov       ah,51h
         int       21h                      ; poskytnut adresy souasnho PSP
         pop       ds
         cmp       bx,ds:[SegRez]           ; je to adresa PSP ?
         je        Instal00                 ; je kompatibiln systm
         or        byte ptr ds:[Param],2    ; pznak nekompatibilnho systmu

; ------ nalezen instalan varianty

Instal00:mov       si,81h                   ; zatek textu pkazovho dku
         xor       cx,cx
         mov       cl,ds:[si-1]             ; poet znak pkazovho dku
Instal01:call      ParmSpc                  ; vyputn mezer z pkaz. dku
         call      ParmCh                   ; ten znaku
         jc        Instal04                 ; konec textu - nen dal znak
         cmp       al,"/"                   ; je parametr ?
         jne       Instal01                 ; nen parametr
         call      ParmCh                   ; naten dalho znaku
         jc        Instal04                 ; konec textu
         cmp       al,"A"
         jb        Instal01
         cmp       al,"Z"
         ja        Instal01
         mov       ds:[UvTxtVar],al         ; varianta instalace
         mov       ds:[Var1],al
         mov       ds:[Var2],al
         mov       ds:[Var3],al
         jmp       short Instal01

; ------ zobrazen vodnho textu

Instal04:mov       dx,offset UvTxt
         mov       ah,9
         int       21h                      ; zobrazen vodnho textu

; ------ dekdovn znaku z pkazovho dku

         mov       es,ds:[SegRez]           ; segment rezidentn sti
         mov       si,81h                   ; zatek pkazovho dku
         xor       cx,cx
         mov       cl,ds:[si-1]             ; poet znak pkazovho dku
         cld                                ; smr nahoru

; ------ nalezen prvnho znaku

Instal1: call      ParmSpc                  ; vyputn mezer z textu
         jc        Inform0                  ; nic nezadno - informace
         call      ParmCh                   ; naten znaku
         jc        Inform0
         cmp       al,"/"
         jne       Instal11
         call      ParmCh
         jc        Chyba
         cmp       al,"A"
         jb        Chyba
         cmp       al,"Z"
         ja        Chyba
         jmp       short Instal1

; ------ rozlien znaku

Instal11:cmp       al,"!"                   ; je odinstalovn ?
         je        OdInst                   ; odinstalovn programu
         cmp       al,"0"                   ; je vypnut ?
         jne       Instal4                  ; nen vypnut

; ------ vypnut kdovn

Instal2: cld                                ; smr nahoru
         mov       di,offset Klic           ; kdovac kl
         xor       al,al                    ; mazac bajt
         mov       cx,KlicN                 ; dlka kle
         rep       stosb                    ; vymazn kle
         and       byte ptr es:[Param],not 1; pznak vypnut funkce
Instal3: mov       dx,offset VypTxt
         mov       ah,9
         int       21h
         jmp       ZadHes8                  ; instalace programu
;         jmp       short Chyba2

; ------ zadno slo disku

Instal4: cmp       al,"Z"
         ja        Chyba                    ; chyba zadn
         sub       al,"A"
         jc        Chyba                    ; chyba zadn
         mov       ds:[Disk],al             ; schova sla disku

         jmp       ZadHesl                  ; zadn hesla

; ------ nen nic zadno - pi prvn instalaci chyba, jinak informace

Inform0: mov       ax,ds
         cmp       ax,ds:[SegRez]           ; byla ji instalace ?
         je        Chyba                    ; nen instalace - chyba

; ------ zobrazen informace o kdovanm disku

Inform:  test      byte ptr es:[Param],1    ; je funkce vypnuta ?
         jz        Instal3                  ; funkce je vypnuta
         mov       al,es:[Disk]             ; kdovan disk
         add       al,"A"                   ; korekce na znak ASCII
         mov       ds:[KodTxt0],al          ; kdovan disk
         mov       dx,offset KodTxt         ; informan text
         jmp       short Chyba2

; ------ zobrazen chybovho textu, konec

Chyba:   mov       dx,offset ErrTxt         ; chybov text
Chyba2:  mov       ah,9
         int       21h                      ; zobrazen chybovho textu

KonecOK: int       20h                      ; nvrat z programu

; -----------------------------------------------------------------------------

; ------ odinstalovn programu - kontrola, zda lze odinstalovat

OdInst:  mov       dx,offset DeInTxt2       ; text - nebyl nainstalovn
         mov       ax,ds                    ; segment tohoto programu
         cmp       ax,ds:[SegRez]           ; je program nainstalovn ?
         je        Chyba2                   ; program nen nainstalovn

; ------ kontrola INT 21h

         mov       dx,offset DeInsTxt       ; chyba - nelze odinstalovat
         mov       ax,3521h
         int       21h                      ; poskytnut adresy peruen 21h
         cmp       bx,offset Int21          ; je to tento vektor ?
         jne       Chyba2                   ; chyba - nelze odinstalovat
         mov       ax,es                    ; segment INT 21h
         cmp       ax,ds:[SegRez]           ; je to rezidentn program ?
         jne       Chyba2                   ; nelze odinstalovat

; ------ kontrola INT 20h

         mov       ax,3520h
         int       21h                      ; poskytnut adresy peruen 20h
         cmp       bx,offset Int20          ; je to tento vektor ?
         jne       Chyba2                   ; chyba - nelze odinstalovat
         mov       ax,es                    ; segment INT 20h
         cmp       ax,ds:[SegRez]           ; je to rezidentn program ?
         jne       Chyba2                   ; nelze odinstalovat

; ------ kontrola INT 27h

         mov       ax,3527h
         int       21h                      ; poskytnut adresy peruen 27h
         cmp       bx,offset Int27          ; je to tento vektor ?
         jne       Chyba2                   ; chyba - nelze odinstalovat
         mov       ax,es                    ; segment INT 27h
         cmp       ax,ds:[SegRez]           ; je to rezidentn program ?
         jne       Chyba2                   ; nelze odinstalovat

; ------ nvrat pvodnho vektoru peruen INT 21h

         mov       es,ds:[SegRez]           ; rezidentn instalace
         push      ds
         lds       dx,es:[Old21]            ; pvodn adresa INT 21h
         mov       ax,2521h
         int       21h                      ; nvrat pvodnho INT 21h
         pop       ds

; ------ nvrat pvodnho vektoru peruen INT 20h

         push      ds
         lds       dx,es:[Old20]            ; pvodn adresa INT 20h
         mov       ax,2520h
         int       21h                      ; nvrat pvodnho INT 20h
         pop       ds

; ------ nvrat pvodnho vektoru peruen INT 27h

         push      ds
         lds       dx,es:[Old27]            ; pvodn adresa INT 27h
         mov       ax,2527h
         int       21h                      ; nvrat pvodnho INT 27h
         pop       ds

; ------ vymazn kdovac tabulky

         cld                                ; smr nahoru
         mov       di,offset Klic           ; kdovac kl
         xor       al,al                    ; mazac bajt
         mov       cx,KlicN                 ; dlka kle
         rep       stosb                    ; vymazn kle

; ------ uvolnn segmentu programu

         mov       ah,49h
         int       21h                      ; uvolnn rezidentn sti

         mov       dx,offset DeIns
         jmp       Chyba2                   ; konec programu

; -----------------------------------------------------------------------------

ZadHesl0:call      Vymaz                    ; vymazn dku
         int       20h

; ------ zadn kdovacho hesla

ZadHesl: mov       dx,offset HesloTxt       ; text vzvy
         mov       ah,9
         int       21h                      ; zadn textu hesla

; ------ vstup jednoho znaku

         xor       cx,cx
         mov       si,offset Buffer         ; buffer k uloen textu hesla
ZadHesl2:mov       ah,7
         int       21h                      ; vstup znaku z klvesnice
         or        al,al                    ; bude Scan kd ?
         jnz       ZadHesl3                 ; je platn znak
         mov       ah,7
         int       21h                      ; ignorovn klvesy
         jmp       short ZadHesl2           ; vstup dalho znaku

; ------ rozlien peruen zadvn textu

ZadHesl3:cmp       al,27                    ; klvesa Esc ?
         je        ZadHesl0                 ; peruen zadvn textu Esc
         cmp       al,3                     ; klvesa Break ?
         je        ZadHesl0                 ; peruen zadvn textu Break

; ------ zruen poslednho znaku

         cmp       al,8                     ; krok zpt ?
         jne       ZadHesl4                 ; nen krok zpt
         jcxz      ZadHesl2                 ; nen dn znak v bufferu
         dec       si                       ; snen ukazatele znak
         dec       cx                       ; snen tae znak
         call      BackSP                   ; vymazn znaku
         jmp       short ZadHesl2           ; vstup dalho znaku

; ------ uloen platnho znaku

ZadHesl4:cmp       al,13                    ; je ukonen volby Enter ?
         je        ZadHesl6                 ; ukonen volby Enter
         cmp       al,"a"                   ; je mal psmeno ?
         jb        ZadHesl5                 ; nen mal psmeno
         cmp       al,"z"
         ja        ZadHesl5
         sub       al,32                    ; korekce na velk psmeno
ZadHesl5:mov       ds:[si],al               ; uloen znaku
         inc       si                       ; zven ukazatele textu
         inc       cx                       ; zven tae znak
         mov       al,"*"                   ; nhradn znak
         call      DispCh                   ; zobrazen znaku
         jmp       short ZadHesl2           ; vstup dalho znaku

; ------ ukonen volby

ZadHesl6:call      Vymaz                    ; vymazn zadanho textu
         or        cx,cx                    ; je nco zadno ?
         jnz       ZadHesl7                 ; je nco zadno
         jmp       Instal2                  ; vypnut programu

; ------ sestaven kdovacho kle

ZadHesl7:or        byte ptr es:[Param],1    ; zapnut programu
         mov       di,offset Klic           ; kdovac kl
         mov       bx,KlicN                 ; dlka kdovacho kle
         mov       dx,-1                    ; vchoz hodnota kdu

; ------ vpoet kdovacho kle

ZadHes77:mov       si,offset Buffer         ; buffer s textem hesla
         call      CheckSum                 ; kontroln souet kle
         mov       es:[di],dl               ; ni bajt kontrolnho soutu
         inc       di                       ; zven ukldac adresy v kli
         dec       bx                       ; ta dlky kle
         jnz       ZadHes77                 ; dal bajt kle

; ------ uloen zadanho disku

         mov       al,ds:[Disk]
         mov       es:[Disk],al             ; nastaven novho disku

; ------ vymazn hesla

         push      es
         push      cs
         pop       es
         cld
         xor       al,al                    ; nulovac bajt
         mov       di,offset Buffer         ; buffer s heslem
         rep       stosb                    ; vymazn hesla
         pop       es

; ------ instalace programu

ZadHes8: mov       ax,ds
         cmp       ax,ds:[SegRez]           ; je program ji instalovn
         jne       ZadHesl9                 ; program je ji instalovn

; ------ instalace INT 21h

         mov       ax,3521h
         int       21h                      ; poskytnut adresy INT 21h
         mov       word ptr ds:[Old21],bx   ; schova offsetu INT 21h
         mov       word ptr ds:[Old21+2],es ; schova segmentu INT 21h
         mov       ax,2521h
         mov       dx,offset Int21          ; nov adresa INT 21h
         int       21h                      ; instalace nov obsluhy INT 21h

; ------ instalace INT 20h

         mov       ax,3520h
         int       21h                      ; poskytnut adresy INT 20h
         mov       word ptr ds:[Old20],bx   ; schova offsetu INT 20h
         mov       word ptr ds:[Old20+2],es ; schova segmentu INT 20h
         mov       ax,2520h
         mov       dx,offset Int20          ; nov adresa INT 20h
         int       21h                      ; instalace nov obsluhy INT 20h

; ------ instalace INT 27h

         mov       ax,3527h
         int       21h                      ; poskytnut adresy INT 27h
         mov       word ptr ds:[Old27],bx   ; schova offsetu INT 27h
         mov       word ptr ds:[Old27+2],es ; schova segmentu INT 27h
         mov       ax,2527h
         mov       dx,offset Int27          ; nov adresa INT 27h
         int       21h                      ; instalace nov obsluhy INT 27h

; ------ uvolnn segmentu prosted

         mov       es,ds:[2ch]              ; segment prosted
         mov       ah,49h
         int       21h                      ; zruen segmentu prosted
         mov       dx,offset Instal         ; konec rezidentn sti
         int       27h                      ; instalace programu


ZadHesl9:int       20h

; -----------------------------------------------------------------------------
;        vymazn dku (CX znak)
; -----------------------------------------------------------------------------

Vymaz    PROC      NEAR

         push      ax
         push      cx
         push      dx
         jcxz      Vymaz3
Vymaz1:  call      BackSP
         loop      Vymaz1
Vymaz3:  mov       dx,offset CrTxt
         mov       ah,9
         int       21h
         pop       dx
         pop       cx
         pop       ax
         ret

Vymaz    ENDP

; -----------------------------------------------------------------------------
;        vymazn znaku na displeji (krok zpt)
; -----------------------------------------------------------------------------

BackSP   PROC      NEAR

         push      ax
         mov       al,8                     ; znak k zobrazen - krok zpt
         call      DispCh
         mov       al," "                   ; mazac znak mezery
         call      DispCh
         mov       al,8                     ; znak k zobrazen - krok zpt
         call      DispCh
         pop       ax
         ret

BackSP   ENDP

; -----------------------------------------------------------------------------
;        zobrazen znaku AL
; -----------------------------------------------------------------------------

DispCh   PROC      NEAR

         push      ax
         push      bx
         push      cx
         push      dx
         push      bp
         push      si
         push      di
         push      ds
         push      es

         mov       ah,0eh
         mov       bx,7
         int       10h

;         mov       ds:[Buff],al
;         mov       bx,2
;         mov       ah,40h
;         mov       cx,1
;         mov       dx,offset Buff
;         int       21h                      ; zpis jednoho znaku na StdErr

;         mov       dl,al
;         mov       ah,2
;         int       21h

         pop       es
         pop       ds
         pop       di
         pop       si
         pop       bp
         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

DispCh   ENDP

; -----------------------------------------------------------------------------
;        vyputn mezer z textu DS:SI/CX
; -----------------------------------------------------------------------------

ParmSpc  PROC      NEAR

ParmSpc1:call      ParmCh
         jc        ParmSpc9                 ; konec textu
         je        ParmSpc1                 ; je oddlova
         dec       si
         inc       cx
ParmSpc9:ret

ParmSpc  ENDP

; -----------------------------------------------------------------------------
;        vstup znaku z pkazovho dku DS:SI/CX
; -----------------------------------------------------------------------------

ParmCh   PROC      NEAR

; ------ test konce textu

         stc
         jcxz      ParmCh9
         cmp       byte ptr ds:[si],13
         stc
         je        ParmCh9

; ------ naten dalho znaku

         cld
         lodsb
         dec       cx

; ------ pevod malch psmen na velk

         cmp       al,"a"
         jb        ParmCh2
         cmp       al,"z"
         ja        ParmCh2
         sub       al,32

; ------ nhrada tabeltoru mezerou

ParmCh2: cmp       al,9
         jne       ParmCh3
         mov       al," "

; ------ pznak, e je oddlova

ParmCh3: cmp       al," "
         clc
ParmCh9: ret

ParmCh   ENDP

; -----------------------------------------------------------------------------
;        Kontroln souet CRC bloku dat
; -----------------------------------------------------------------------------
; VSTUP: DS:SI=zatek bloku dat
;        CX=poet bajt
;        DX=vstupn hodnota kontrolnho soutu
; VSTUP:DX=vstupn hodnota kontrolnho soutu
; -----------------------------------------------------------------------------

PUBLIC   CheckSum

CheckSum PROC      NEAR

         push      ax
         push      cx
         push      di
         jcxz      CheckSm2                 ; nejsou dn data
         mov       di,cx                    ; poet bajt pro kontroln souet
         cld                                ; smr nahoru

CheckSm1:lodsb                              ; a = fgetc(fp);
         xor       al,dh                    ; d = a ^= d;
         mov       dh,al
         mov       cl,4
         shr       al,cl                    ; a >>= 4;
         xor       al,dh                    ; d = a ^= d;
         mov       dh,al
         mov       cl,3
         ror       al,cl                    ; a = (a >> 3) | (a << 5);
         mov       ch,al                    ; f = a;
         and       al,1fh                   ; a &= 0x1f;
         xor       al,dl                    ; e = a ^= e;
         mov       dl,al
         mov       al,ch                    ; a = f;
         ror       al,1                     ; a = (a >> 1) | (a << 7);
         and       al,0f0h                  ; a &= 0xf0;
         xor       al,dl                    ; e = a ^= e;
         mov       dl,al
         mov       al,ch                    ; a = f & 0xe0;
         and       al,0e0h
         xor       al,dh                    ; a ^= d;
         mov       dh,dl                    ; d = e;
         mov       dl,al                    ; e = a;

         dec       di
         jnz       CheckSm1                 ; dal bajt

CheckSm2:pop       di
         pop       cx
         pop       ax
         ret

CheckSum ENDP


; -----------------------------------------------------------------------------
;        data
; -----------------------------------------------------------------------------

VypTxt   db        'Kodovani vypnuto.'
CrTxt    db        13,10,'$'

Buff     db        0

Buffer   label     byte                     ; buffer k uloen textu hesla

KodTxt   db        'Aktivni kodovany disk '
KodTxt0  db        'A:',13,10,'$'

ErrTxt   db        'Parametry: A: az Z: = kodovaci heslo pro disk A az Z',13,10
         db        '           ...  nebo 0 = vypnuti, !=odinstalovani',13,10
         db        '          /A az /Z = instalacni varianta A az Z',13,10,'$'

DeInsTxt db        'KODDISK ['
Var1     db        'A] nelze odinstalovat z pameti !',13,10,'$'
DeInTxt2 db        'KODDISK ['
Var2     db        'A] nebyl dosud nainstalovan !',13,10,'$'

DeIns    db        'KODDISK ['
Var3     db        'A] byl odinstalovan.',13,10,'$'

HesloTxt db        'Zadejte heslo a <Enter>: $'

Code     ENDS
         END       Start
